  processor 6502

  seg
  org $8000
  byte 0
  org $8100
  nop $1FF8

  org $8155  ; Jumping-in point in $1FF9 block (from $1FF8)
  nop $1FF9

  org $8169  ; Jumping-in point in $1FF8 block (from $1FF9)
  nop $1FF8

  org $8553  ; Jumping-out point in $1FF9 block (going to $1FF8)
  jmp $5169

  org $8C39  ; Jumping-out point in $1FF8 block (going to $1FF9)
  jmp $5155

  org $8FFC
  word $9100,$9100
  org $9100
  nop $1FF8

  org $9871-3  ; Draw things on scanner here
drawx:
  nop $1FF8
  jmp do_draw

  org $9908
x908:
  nop $1FF8
do_draw:
  lda #$00
tmpaddr .set $F04F
  repeat 42
    sta tmpaddr
tmpaddr .set tmpaddr+1
  repend

 if 0
  ldy #6
zlp:
  sta $F04F,y
  sta $F04F+7,y
  sta $F04F+14,y
  sta $F04F+21,y
  sta $F04F+28,y
  sta $F04F+35,y
  dey
  bpl zlp  
 endif

  lda $81
  and #7
  tax
  lda cbtable,x
  sta $F07F
  and #$55
  bne no_humanoids
  ldx $f080 ; X scroll position
  ldy xdtable,x

  lda $D6
  lsr
  bcc no_c0_human
  sty $F04F+14
no_c0_human:
  lsr
  bcc no_c1_human
  sty $F04F+21
no_c1_human:
  lsr
  bcc no_c2_human
  sty $F04F+28
no_c2_human:
  lsr
  bcc no_c3_human
  sty $F04F+35
no_c3_human:
  lsr
  lsr
  lsr
  bcc no_c4_human
  sty $F04F+0
no_c4_human:
  lsr
  bcc no_c5_human
  sty $F04F+7
no_c5_human:
no_humanoids:
  ldx #15
dlp:
  dex
  bmi dlp_exit
dlp1:
  ldy $F0A2,x
  beq dlp
  cpy #16
  bcs dlp
  lda ctable,y
  beq abductor
  bit $70FF
  beq dlp

  ldy $F0B2,x
  lda xatable,y
  beq dlp
  ldy $F082,x
  bpl fine
  adc #7 ; Carry is clear here
fine:
  ldy $E0,x ; Y position
  adc ytable,y  ; Carry is clear here
  sta $F1
f1_stowed:
  ldy $F082,x  ; X position low byte
  lda xdtable,y
  ldy $F1
  ora $F0CE,y
  sta $F04E,y
dlp_alt:
  dex
  bpl dlp1
dlp_exit:
  ldx $F0FA
  lda FAtbl,x
  sta $F07A

  lda $81
  lsr
  lda #$B4
  ror
  sta $f07F

  ;lda $D6
  ;and #3
  ;sta $D6

  ldx $A9
  beq noboom
  cpx #28
  bne boom
  ldx #42
noboom:
  stx $9B
  lda #$FE
  sta $9C

  lda $88
  clc
  adc #$4C
  bcs adj87
  cmp #$D0
  bcc stow87
adj87:
  sbc #$A0
stow87:
  sta $87

  ;lda #$7C
  ;sta $87
  ;lda #$30
  ;sta $88
  
  jmp [x908 & $0FFF] | $D000
boom:
  lda boomtab_87,x
  sta $87
  lda boomtab_88,x
  sta $88
  lda $80
  ora #$F0
  sta $9C
  cpx #27
  beq boomend
  jmp [x908 & $0FFF] | $D000
boomend:
;  ldx #1
;  stx $A9
  jmp [x908 & $0FFF] | $D000
 
abductor:
  ldy $F0B2,x
  lda xatable,y
  beq dlp_alt
  ldy $F082,x
  bpl abfine
  adc #7 ; Carry is clear here
abfine:
  ldy $E0,x ; Y position
  adc ytable,y  ; Carry is clear here
  sta $F1
  lda $81
  and #1
  bne f1_stowed
  dec $f1
  jmp f1_stowed

  org $9B00
xatable:
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  byte 15,29,0,1,15,29,0,1, 15,29,0,1,15,29,0,1
  ;  Old version was byte 15,22,29,36,0,0,1,8
xdtable:
  byte $80,$80,$80,$80, $80,$80,$80,$80, $80,$80,$80,$80, $80,$80,$80,$80
  byte $40,$40,$40,$40, $40,$40,$40,$40, $40,$40,$40,$40, $40,$40,$40,$40
  byte $20,$20,$20,$20, $20,$20,$20,$20, $20,$20,$20,$20, $20,$20,$20,$20
  byte $10,$10,$10,$10, $10,$10,$10,$10, $10,$10,$10,$10, $10,$10,$10,$10
  byte $08,$08,$08,$08, $08,$08,$08,$08, $08,$08,$08,$08, $08,$08,$08,$08
  byte $04,$04,$04,$04, $04,$04,$04,$04, $04,$04,$04,$04, $04,$04,$04,$04
  byte $02,$02,$02,$02, $02,$02,$02,$02, $02,$02,$02,$02, $02,$02,$02,$02
  byte $01,$01,$01,$01, $01,$01,$01,$01, $01,$01,$01,$01, $01,$01,$01,$01
  byte $80,$80,$80,$80, $80,$80,$80,$80, $80,$80,$80,$80, $80,$80,$80,$80
  byte $40,$40,$40,$40, $40,$40,$40,$40, $40,$40,$40,$40, $40,$40,$40,$40
  byte $20,$20,$20,$20, $20,$20,$20,$20, $20,$20,$20,$20, $20,$20,$20,$20
  byte $10,$10,$10,$10, $10,$10,$10,$10, $10,$10,$10,$10, $10,$10,$10,$10
  byte $08,$08,$08,$08, $08,$08,$08,$08, $08,$08,$08,$08, $08,$08,$08,$08
  byte $04,$04,$04,$04, $04,$04,$04,$04, $04,$04,$04,$04, $04,$04,$04,$04
  byte $02,$02,$02,$02, $02,$02,$02,$02, $02,$02,$02,$02, $02,$02,$02,$02
  byte $01,$01,$01,$01, $01,$01,$01,$01, $01,$01,$01,$01, $01,$01,$01,$01
sxdtable:
cbtable:
  byte 128,64,32,16,8,4,2,1
ytable:  ; DCD8
  byte 255,255,255,255,255,255,255,255
  byte 0,0,0,0,0,0,0,0
  byte 0,0,0,0,0,0,0,0
  byte 1,1,1,1,1,1,1,1
  byte 1,1,1,1,1,1,1,1
  byte 2,2,2,2,2,2,2,2
  byte 2,2,2,2,2,2,2,2
  byte 3,3,3,3,3,3,3,3
  byte 3,3,3,3,3,3,3,3
  byte 3,3,3,3,3,3,3,3
  byte 4,4,4,4,4,4,4,4
  byte 4,4,4,4,4,4,4,4
  byte 5,5,5,5,5,5,5,5
  byte 5,5,5,5,5,5,5,5
  byte 6,6,6,6,6,6,6,6
  byte 6,6,6,6,6,6,6,6
  byte 6,6,6,6,6,6,6,6
  byte 6,6,6,6,6,6,6,6
  byte 6,6,6,6,6,6,6,6
  byte 6,6,6,6,6,6,6,6

  ;byte 255,0,0,1, 1,2,2,3, 3,3,4,4, 5,5,6,6, 6,6,6,6
FAtbl:
  byte 1,2,3,6,0,0,7,0
ctable:
  byte %11111111  ; 0 No enemy
  byte %10100101  ; 1 Baiter
  byte %10100101  ; 2 Munchie
  byte %10100101  ; 3 Phred
  byte %10100100  ; 4 Mutant
  byte %10100101  ; 5 Guppy
  byte %11001100  ; 6 Three swarmers
  byte %11001100  ; 7 Two swarmers
  byte %11001100  ; 8 One swarmer
  byte %01010101  ; 9 Lander
  byte %10100101  ; A Dynamo
  byte %11110000  ; B Pod
  byte %10100101  ; C Firebomber
  byte %00000000  ; D Abductor
  byte %10101010  ; E Humanoid (falling safe)
  byte %10100000  ; F Humanoid (falling danger)

boomtab_87:
  byte $46,$57,$93, $73,$C3,$D4, $A8,$C3,$91
  byte $46,$57,$93, $73,$C3,$D4, $A8,$C3,$91
  byte $46,$57,$93, $73,$C3,$D4, $A8,$C3,$91
  byte $7C
boomtab_88:
  byte $46,$57,$93, $73,$C3,$D4, $A8,$C3,$91
  byte $46,$57,$93, $73,$C3,$D4, $A8,$C3,$91
  byte $46,$57,$93, $73,$C3,$D4, $A8,$C3,$91
  byte $30

  org $9FFC
  word $9100,$9100

  end






